new Handle:OnClientBuy;
new Handle:ZmMenuStyle;
#define SAY_COUNT 6
static String:Say_types[SAY_COUNT][] = { "zmmenu" , "menu" , "/menu" , "/zmmenu", "upgrades" , "/upgrades" }

stock StartMenu(){
	RegConsoleCmd("say", Command_Say);
	RegConsoleCmd("say_team", Command_Say);
	RegConsoleCmd("zmmenu", Command_Menu);
	
	ZmMenuStyle = GetMenuStyleHandle(MenuStyle_Radio);
	
	OnClientBuy=CreateGlobalForward("ZM_UpgradeUP",ET_Ignore,Param_Cell,Param_Cell,Param_Cell);	
}

public Action:Command_Say(client, args)
{
	decl String:szText[12];
	GetCmdArgString(szText, sizeof(szText));
	
	//TrimString(szText);
	
	for(new i =0; i<= SAY_COUNT; i++){
		if(StrEqual(szText, Say_types[i],true)){
			ShowMenu(client);
			break;	
		}
	}
		
	return Plugin_Continue;  
}

public Action:Command_Menu(client, args)
{
	ShowMenu(client); 
	return Plugin_Handled;
}

public ShowMenu(client){ 	
	//new Handle:menu = CreateMenu(MenuHandler1);
	decl String:buffer[8], String:Final[64]
	new count = GetUpgrateCount();
	
	//#if DEBUG == 1
	//LogMessage("Adding menu items - %d",count);
	//#endif
	
	if(count == 0)
		return;
	
	new Handle:menu = CreateMenuEx(ZmMenuStyle, MenuHandler1);
	SetMenuTitle(menu, "ZM Upgrates\nYou have %d points left", Getfreepoints(client));
	
	for(new i = 0; i < count ; i++){
	 	IntToString( i , buffer, sizeof(buffer) ) ;
	 	GetUpgrateName(i , Final, sizeof(Final) ) ;
		Format(	Final, sizeof(Final), "%s (%d/%d)", Final, GetUpgrateLevel( client, i) , GetUpgrateMax( i ));
		#if DEBUG == 1
			//LogMessage("--%s", Final);
		#endif
		AddMenuItem(menu, buffer, Final);
	}
	DisplayMenu(menu, client, 20);
	
}

public MenuHandler1(Handle:menu, MenuAction:action, client, param2)
{ 
	/* Either Select or Cancel will ALWAYS be sent! */
	if (action == MenuAction_Select)
	{
	 	decl String:info[36];		
		if(!GetMenuItem(menu, param2, info, sizeof(info)))
			return;
		
		//How I hate to this "inttostring", "strtoint"	thing
		new opt, otherinfo[2];
		opt = StringToInt( info );
		
		LastAction[ client ] = opt;
		
		decl String:Name[33], String:description[256];
		
		GetUpgrateName(opt, Name, sizeof(Name));
		GetUpgrateDesc(opt, description, sizeof(description));
		
		otherinfo[0] = GetUpgrateLevel( client, opt);
		otherinfo[1] = GetUpgrateMax( opt );
		
		new Handle:menu2 = CreateMenuEx(ZmMenuStyle, PanelHandler1);
		SetMenuTitle(menu2, "%s:\nLevel %d / %d\n%s", Name, otherinfo[0] , otherinfo[1] ,description);
		
		if(otherinfo[0] < otherinfo[1]){
			new freepoints = Getfreepoints(client);
			if(freepoints > 0)
				AddMenuItem(menu2, "buy1", "Buy x 1");
			if(freepoints > 1)
				AddMenuItem(menu2, "buy2", "Buy x 2");
			if(freepoints > 2)
				AddMenuItem(menu2, "buy3", "Buy x 3");
		}
		
		AddMenuItem(menu2, "back", "Go back");

		DisplayMenu(menu2, client, 20);
	 	
	} 
	/* If the menu has ended, destroy it */
	else if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
}

public PanelHandler1(Handle:menu, MenuAction:action, client, param2)
{
 	#if DEBUG == 1
 		LogMessage("Buying stuff!");
 	#endif
	if (action == MenuAction_Select)
	{
		decl String:info[36];		
		if(!GetMenuItem(menu, param2, info, sizeof(info)))
			return;
		
		#if DEBUG == 1
			LogMessage("--Menu answer: %s %s %d", info, info[3],StrContains(info, "buy"));
		#endif
			
		if(StrContains(info, "buy") == -1){
			ShowMenu(client);
			return;
		}
		
		decl String:Name[33];
		new spendcount, otherinfo[2];
		spendcount = StringToInt( info[3] );
		GetUpgrateName(LastAction[ client ], Name, sizeof(Name));
		
		otherinfo[0] = GetUpgrateLevel( client, LastAction[ client ]);
		otherinfo[1] = GetUpgrateMax( LastAction[ client ] );
		
		if(spendcount > otherinfo[1] - otherinfo[0])
				spendcount = otherinfo[1] - otherinfo[0];
				
		if(Getfreepoints(client) < spendcount){
			PrintToChat(client, "[ZMup] You do not have enough points for that.");
			return;
		}	
		
		SetUpgrateLevel(client, LastAction[ client ], spendcount, true);
		
		CalculateFreePoints(client);
		
		PrintToChat(client, "[ZMup] You just put %d point into %s. You now have %d free points.", spendcount, Name, Getfreepoints(client));
		
			
		Call_StartForward(OnClientBuy);
		Call_PushCell(client);
		Call_PushCell(LastAction[ client ]);
		Call_PushCell(spendcount);
		Call_Finish();
		
		ShowMenu(client);
	} else if (action == MenuAction_End) {
		CloseHandle(menu);
	}
}
