#define PL_VERSION "1.1"
#define DEBUG 1

#include <sourcemod>
#include <sdktools>
#include <globaldb>
#include <..\ZMup\init>

public Plugin:myinfo = 
{
	name = "Zombie Master Upgrates",
	author = "Nican",
	description = "",
	version = PL_VERSION,
	url = "http://www.sourcemod.net/"
};
 
public OnPluginStart() 
{
	StartMenu();
	AssignCvars();
	Upgrates[UPGRATE_INFO]        = CreateArray( UPGRATE_INFO_COUNT );
	Upgrates[UPGRATE_DBNAME]        = CreateArray( ByteCountToCells(33) );
	Upgrates[UPGRATE_NAME]        = CreateArray( ByteCountToCells(33) );
	Upgrates[UPGRATE_DESCRIPTION] = CreateArray( ByteCountToCells(384) );
	
	if(!HookEventEx("round_restart",Event_RoundEnd))
		LogMessage("Unable to hook round_restart! Players WILL NOT win XP");
		
	AutoExecConfig(true, "zmupgrates");
}  

public Action:Event_RoundEnd(Handle:event, const String:name[], bool:dontBroadcast){	
	GivePlayersXP();
}

public bool:AskPluginLoad(Handle:myself, bool:late, String:Error[]){
	StartHelper();
	StartDbNatives();	
	return true;  
}


public DB_OnRowsUpdated(){
	Db_playerxp = DB_GetColumnId("ZmXp", true, true);
}

public OnMapStart(){
	maxplayers = GetMaxClients();
}
/*
public OnMapEnd(){
	GivePlayersXP();
}
*/
