new ResourceOffset;
#define MONSTER_COUNT 4
static String:Monster_names[MONSTER_COUNT][] = { "npc_zombie" , "npc_fastzombie" , "npc_poisonzombie" , "npc_dragzombie"}

stock StartHelper(){
	CreateNative("ZM_SetHealth", zm_SetHealth);
	CreateNative("ZM_SetMaxHealth", zm_SetMaxHealth);
	CreateNative("ZM_GetMaxHealth", zm_GetMaxHealth);
	
	CreateNative("ZM_SetResouces", zm_SetResouces);
	CreateNative("ZM_GetResouces", zm_GetResouces);
	
	CreateNative("ZM_isNPC", zm_isNPC);
	CreateNative("ZM_Check", zm_CheckStatus);
	
}

stock HelperOffsets(){
	ResourceOffset=FindSendPropOffs("CBasePlayer","m_iZombiePool");
  	if(ResourceOffset==-1)
    	LogMessage("[ZmUP] ATTETION: PLUGIN MAY NOT WORK CORRECTLY, m_iZombiePool NOT FOUND");
}

/**************************************************************************/

public zm_CheckStatus(Handle:plugin,argc){
 	if(argc != 2)
 		return -1;
	new client, bool:message;
	client = GetNativeCell(1);
	
	if(client == 0)
		return false;
	
	if(!IsClientInGame(client))
		return false;
		
	message = GetNativeCell(2);
	
	if(GetClientTeam(client) != 2){
		if(message)
			PrintToChat(client, "[ZMup] You can only do this while you are on survivors");		
		return false;
	}
	
	if(!IsPlayerAlive(client)){
	 	if(message)
			PrintToChat(client, "[ZMup] You are dead!");
		return false;
	}
	
	return true;
}

/**************************************************************************/
new iMaxHealth[ MAXPLAYERS + 1];

//Client, health
public zm_SetHealth(Handle:plugin,argc){
 	if(argc != 3)
 		return -1;
	new health,client;
	client = GetNativeCell(1);
	health = GetNativeCell(2); 
	
	if(GetNativeCell(3))
		health = health + GetClientHealth(client);
		
	if(health > iMaxHealth[client])
		health = iMaxHealth[client];
		
	if(health <= 0){
        FakeClientCommandEx( client, "kill");
        return true;
    }
	
	//SetEntProp(client, Prop_Send, "m_iHealth", health, 1);
	SetEntityHealth(client, health) ;
	return true;
}

//Client
public zm_GetMaxHealth(Handle:plugin,argc){
 	if(argc != 1)
 		return -1;
	
	return iMaxHealth[ GetNativeCell(1) ];
}

//Client, health, bool:add
public zm_SetMaxHealth(Handle:plugin,argc){
 	if(argc != 3)
 		return false;
 		
 	if(GetNativeCell(3))
 		iMaxHealth[ GetNativeCell(1) ] += GetNativeCell(2);
 	else
 		iMaxHealth[ GetNativeCell(1) ] = GetNativeCell(2);
 	
 	return true;
}


/**************************************************************************/
//Client, amout, bool:add
public zm_SetResouces(Handle:plugin,argc){
 	if(argc != 3)
 		return -1;
 	
 	SetZMResources(GetNativeCell(1), GetNativeCell(2), GetNativeCell(3));
	return 1;
}

//Client
public zm_GetResouces(Handle:plugin,argc){
 	if(argc == 1)
		return GetZMZMResources(GetNativeCell(1));
	return -1;
}

stock SetZMResources(client, amount, bool:add = false){
	if(add) amount +=  GetZMZMResources(client);
	SetEntData(client, ResourceOffset, amount, 4, true);
}

stock GetZMZMResources(client){
	return GetEntData(client, ResourceOffset, 4);
}

/**************************************************************************/

//monster id
public zm_isNPC(Handle:plugin,argc){
 	if(argc != 1)
		return -1;
		
	decl String:monster_name[20];
	if(!GetEdictClassname(GetNativeCell(1), monster_name, sizeof(monster_name))){
        return -1;
    }
	
	for(new i = 0; i< MONSTER_COUNT; i++){
		if(StrEqual(monster_name, Monster_names[i],false)){
		 	//LogMessage("Passing %s", monster_name)
			return i;			
		}
	}
	return -1;
}
