#define VERSION "Beta#1"

#include <sourcemod>
#include <sdktools>
#include <zmup>

public Plugin:myinfo = 
{
	name = "ZM Damage iginite",
	author = "Nican",
	description = "",
	version = VERSION,
	url = "http://www.sourcemod.net/"
};

new ZMup_id;
new maxents;
new OriginOffset


#define CVAR_STARTDIS 0 //Distance
#define CVAR_PERLEVELDIS 1
#define CVAR_STARTPRO 2 //Probality of happining
#define CVAR_PERLEVELPRO 3
#define CVAR_STARTTIME 4 //Fire time
#define CVAR_PERLEVELTIME 5
#define CVAR_ONDEATH 6

#define CVAR_COUNT 7

new Handle:g_cvars[CVAR_COUNT];


public OnPluginStart() 
{
	HookEvent("player_hurt",PlayerHurtEvent);
	
	maxents = GetMaxEntities();
	
	//So many Cvars!!
	g_cvars[CVAR_STARTDIS] = CreateConVar("sm_zm_fire_distancestart","24.0","The disatance that fire will afect to");
	g_cvars[CVAR_PERLEVELDIS] = CreateConVar("sm_zm_fire_distancelevel","8.0","The disatance that fire distance will increase for each level");
	g_cvars[CVAR_STARTPRO] = CreateConVar("sm_zm_fire_probality","23","What is the probability of player actually igining the entity");
	g_cvars[CVAR_PERLEVELPRO] = CreateConVar("sm_zm_fire_probabilitylevel","1","How much the probability will decrease for each level");
	g_cvars[CVAR_ONDEATH] = CreateConVar("sm_zm_fire_ondeath","4","The probability of zombies getting on fire when players die");
	g_cvars[CVAR_STARTTIME] = CreateConVar("sm_zm_fire_time","3.0","Time zombie will burn");
	g_cvars[CVAR_PERLEVELTIME] = CreateConVar("sm_zm_fire_timelevel","0.25","Time zombie will burn increasiment per level");
	
	OriginOffset=FindSendPropOffs("CBaseEntity","m_vecOrigin");
	if(OriginOffset==-1)
    	LogMessage("[ZmUP:Fire] ATTETION: m_vecOrigin not found! Plugin WILL not work correctly");
}

public DB_OnRowsUpdated(){
	ZMup_id = ZM_StartUpgrate("zmup_Explode", "Iginite", "There is a change of zombies around\n can get on fire when you are hit", 13);
}

public PlayerHurtEvent(Handle:event,const String:name[],bool:dontBroadcast)
{
	new client=GetClientOfUserId(GetEventInt(event,"userid"));
	
	new iLevel = ZM_GetLevel(client, ZMup_id);
	if(iLevel == 0)
		return;
		
	new Float:MaxDisance = GetConVarFloat(g_cvars[CVAR_STARTDIS]) + (GetConVarFloat(g_cvars[CVAR_PERLEVELDIS]) * iLevel);
	new probability = GetConVarInt(g_cvars[CVAR_STARTPRO]) - (GetConVarInt(g_cvars[CVAR_PERLEVELPRO]) * iLevel);
	if(GetEventInt(event,"health") == 0)
		probability = GetConVarInt(g_cvars[CVAR_ONDEATH]);
	
	new Float:BurnTime = GetConVarFloat(g_cvars[CVAR_STARTTIME]) + (GetConVarFloat(g_cvars[CVAR_PERLEVELTIME]) * iLevel);
	
	if(probability <= 0)
		return;
	
	new Float:clientvec[3], Float:monstervec[3];
	GetEntDataVector(client, OriginOffset, clientvec);
	
	for(new i = 1; i <= maxents ; i++ ){
	 	if(!IsValidEntity(i))
	 		continue;
	 	
	 	//I hate this isNPC version, i would love to call the SDK one (CBaseEntity::IsNPC()), but it does not work
		if(ZM_isNPC(i) == -1)
			continue;
		
		//Sometimes probalility can be nagative, so lets use ">" instead of "!="
		if(GetRandomInt(0, probability) > 0)
			continue;
		
		GetEntDataVector(i, OriginOffset, monstervec);		
				
		if(GetVectorDistance(clientvec, monstervec) < MaxDisance){
		 	//LogMessage("Burning zombie! Distance: %f | Time: %f", GetVectorDistance(clientvec, monstervec), BurnTime)
			IgniteEntity(i, BurnTime);	
		}
	}
}